#ifndef _HATPTOOLS_H
#define _HATPTOOLS_H

#include <vector>
#include <string>
#include <cstring>
#include <sstream>

using namespace std;

// ---------- String tools ----------

static string& str_replace(const string &search, const string &replace, string &subject) {
    string buffer;
    int sealeng = search.length();
    int strleng = subject.length();
    if (sealeng==0) return subject;
    for(int i=0, j=0; i<strleng; j=0 ) {
        while (i+j<strleng && j<sealeng && subject[i+j]==search[j]) j++;
        if (j==sealeng) {buffer.append(replace); i+=sealeng;}
        else buffer.append( &subject[i++], 1);
    }
    subject = buffer;
    return subject;
}

static string& removeFormatting(string &s) {
	return str_replace(" ", "", s);
}

static string& removeQuotes(string &s) {
	return str_replace("\"", "", s);
}

static vector<string> tokenizeStr(string content, const char* separator) {
	vector<string> result;
	char *token, *schar;
	schar = new char[content.size()+1];
	strcpy (schar, content.c_str());
	token = strtok(schar, separator);
	while (token != NULL) {
		result.push_back(token);
		token = strtok(NULL, ",");
	}
	return result;
}

static vector<unsigned int> tokenizeInt(string content, const char* separator) {
	vector<unsigned int> result;
	vector<string> temp = tokenizeStr(content, separator);
	istringstream tokenStr; unsigned int tokenInt;
	for(unsigned int i = 0 ; i < temp.size() ; i++) {
		tokenStr.clear(); tokenStr.str(temp[i]);
		tokenStr >> tokenInt;
		result.push_back(tokenInt);
	}
	return result;
}

#endif
